import '@hotwired/turbo-rails';

import { far } from '@fortawesome/free-regular-svg-icons';
import { fas } from '@fortawesome/free-solid-svg-icons';
import { fab } from '@fortawesome/free-brands-svg-icons';
import { library } from '@fortawesome/fontawesome-svg-core';
import '@fortawesome/fontawesome-free';

library.add(far, fas, fab);
FontAwesome.config.mutateApproach = 'sync';

import 'controllers';

Turbo.StreamActions.change_counter = function () {
  const element = this.targetElements[0];

  if (element) {
    const changeAmount = parseInt(this.getAttribute('amount'), 10);
    const currentValue = parseInt(element.textContent, 10);
    const startIndexElement = element.parentElement.querySelector('#start_index');

    if (!isNaN(currentValue) && !isNaN(changeAmount)) {
      element.textContent = currentValue + changeAmount;
      if (element.textContent < 0) {
        element.textContent = 0;
      }
      if (element.textContent == 0) {
        if (startIndexElement) {
          startIndexElement.textContent = 0;
        }
      }
    }
  }
};
