import { Controller } from '@hotwired/stimulus';

export default class extends Controller {
  static targets = ['content', 'icon'];

  connect() {
    this.isOpen = false;
    this.updateIcon();
  }

  toggle() {
    this.isOpen = !this.isOpen;
    this.contentTarget.classList.toggle('hidden', !this.isOpen);
    this.updateIcon();
  }

  updateIcon() {
    this.iconTarget.classList.toggle('fa-chevron-up', this.isOpen);
    this.iconTarget.classList.toggle('fa-chevron-down', !this.isOpen);
  }
}
