import { Controller } from '@hotwired/stimulus';

export default class extends Controller {
  static targets = ['item'];

  connect() {}

  toggle(event) {
    const isChecked = event.target.checked;
    if (isChecked) {
      this.show();
    } else {
      this.hide();
    }
  }

  hide() {
    this.itemTargets.forEach(item => {
      item.classList.add('hidden');
    });
  }

  show() {
    this.itemTargets.forEach(item => {
      item.classList.remove('hidden');
    });
  }
}
