import { Controller } from '@hotwired/stimulus';

export default class extends Controller {
  static targets = ['downloadLink'];

  connect() {
    this.select = this.element.querySelector('select');

    this.select.addEventListener('change', () => {
      this.updateDownloadLink();
    });
  }

  disconnect() {
    this.select.removeEventListener('change', () => {
      this.updateDownloadLink();
    });
  }

  updateDownloadLink() {
    const docId = this.select.value;

    this.downloadLinkTarget.classList.toggle('hidden', !docId);
    this.downloadLinkTarget.href = `/documents/${docId}/upload?mode=attachment`;
  }
}
