import { Controller } from '@hotwired/stimulus';

export default class extends Controller {
  static targets = ['form', 'display', 'input'];

  connect() {}

  disconnect() {
    if (this.hasInputTarget) {
      this.inputTarget.removeEventListener('blur', this.boundSaveHandler);
    }
  }

  save() {
    this.formTarget.requestSubmit();
  }

  startEditing(event) {
    event.preventDefault();
    event.stopPropagation();

    // Prevent multiple edits
    if (document.querySelector('.editing-active')) {
      return;
    }

    this.displayTarget.classList.add('hidden');
    this.formTarget.classList.remove('hidden');
    this.element.classList.add('editing-active');
    this.inputTarget.focus();
    this.inputTarget.select();

    this.boundSaveHandler = this.save.bind(this);
    this.inputTarget.addEventListener('blur', this.boundSaveHandler);
    this.inputTarget.addEventListener('keydown', this.boundKeydownHandler);
  }
}
