import { Controller } from '@hotwired/stimulus';

export default class extends Controller {
  static targets = ['backdrop', 'content'];

  connect() {
    this.backdropTarget.addEventListener('click', this.handleClickOutside.bind(this));
  }

  disconnect() {
    this.backdropTarget.removeEventListener('click', this.handleClickOutside);
  }

  submitEnd(event) {
    if (event.detail.success) {
      this.hideModal();
    }
  }
  hideModal() {
    this.element.remove();
  }

  handleClickOutside(event) {
    if (event.target === event.currentTarget) {
      this.hideModal();
    }
  }
}
