import * as pdfjsLib from 'pdfjs-dist';
import BaseForm from 'controllers/base_form_controller';
import { renderThumbnails } from 'helpers/pdf_thumbnails';

export default class extends BaseForm {
  static targets = ['thumbnailContainer'];
  static THUMBNAIL_SIZE = 320;

  static values = {
    src: String,
    workerUrl: String,
  };

  connect() {
    super.connect();
    this.loadPDF();
  }

  disconnect() {
    super.disconnect();
  }

  async loadPDF() {
    pdfjsLib.GlobalWorkerOptions.workerSrc = this.workerUrlValue;

    try {
      this.pdf = await pdfjsLib.getDocument({ url: this.srcValue, maxCanvasBytes: 10000000, disableFontFace: true, scale: 0.1 }).promise;
      this.totalPagesValue = this.pdf.numPages;
      await renderThumbnails.call(this);
    } catch (error) {
      console.error('Error loading PDF:', error);
    }
  }
}
