# frozen_string_literal: true

module ActionButtons
  class BaseButtonComponent < BaseComponent
    attr_reader :show_text

    DEFAULT_CLASSES = {
      button: 'flex flex-row items-center justify-start p-[13px] isolate disabled:opacity-50 group text-sm',
      button_color: 'hover:bg-gray-200',
      icon: 'w-6 font-light text-xl leading-5',
      icon_color: 'text-[#80939E] group-hover:text-primary',
      show_text: 'w-full gap-2',
      small_size: 'w-[44px] justify-center'
    }.freeze

    def initialize(show_text: false)
      super
      @show_text = show_text
    end

    def button_classes
      "#{DEFAULT_CLASSES[:button]} #{button_size_classes} #{DEFAULT_CLASSES[:button_color]}".strip
    end

    def button_size_classes
      show_text ? DEFAULT_CLASSES[:show_text] : DEFAULT_CLASSES[:small_size]
    end

    def icon_classes
      "#{DEFAULT_CLASSES[:icon]} #{DEFAULT_CLASSES[:icon_color]}".strip
    end
  end
end
