# frozen_string_literal: true

module ActionButtons
  class DeleteButtonComponent < BaseButtonComponent
    attr_reader :tagset, :user

    def initialize(tagset:, user:, show_text: false)
      super(show_text:)
      @tagset = tagset
      @user = user
    end

    def title
      'Supprimer'
    end

    def render?
      SpiritHub::TagsetsPolicy.new(user, tagset).delete_item?
    end
  end
end
