# frozen_string_literal: true

module ActionButtons
  class DirectoryDeleteButtonComponent < BaseButtonComponent
    attr_reader :tagset, :user, :directory_id, :parent_ids

    def initialize(tagset:, user:, show_text: false, options: {})
      super(show_text:)
      @tagset = tagset
      @user = user
      @directory_id = options.fetch(:directory_id, nil)
      @parent_ids = options.fetch(:parent_ids, nil)
    end

    def title
      'Supprimer'
    end

    def render?
      SpiritHub::TagsetsPolicy.new(user, tagset).delete_item?
    end
  end
end
