# frozen_string_literal: true

module ActionButtons
  class DuplicateButtonComponent < BaseButtonComponent
    attr_reader :tagset, :user, :directory

    def initialize(tagset:, user:, directory:, show_text: false)
      super(show_text:)
      @tagset = tagset
      @user = user
      @directory = directory
    end

    def title
      'Dupliquer'
    end

    def render?
      return false unless tagset.directory?
      return false unless SpiritHub::TagsetDuplicater.can_duplicate?(tagset)

      SpiritHub::DirectoriesPolicy.new(user, tagset).duplicate?
    end
  end
end
