# frozen_string_literal: true

module ActionButtons
  class OfficeButtonComponent < BaseButtonComponent
    attr_reader :tagset, :doc, :user

    def initialize(tagset:, user:, show_text: false)
      super(show_text:)
      @tagset = tagset
      @doc = tagset.doc
      @user = user
    end

    def render?
      doc&.wopi_editable? && SpiritHub::TagsetsPolicy.new(user, tagset).office_editable?
    end
  end
end
