# frozen_string_literal: true

module ActionButtons
  class ShareFromInfoButtonComponent < BaseButtonComponent
    attr_reader :tagset, :user

    def initialize(tagset:, user:, show_text: false)
      super(show_text:)

      @tagset = tagset
      @user = user
    end

    def title
      if tagset.one_doc?
        'Partager à partir des informations du document'
      elsif tagset.multiple_doc?
        'Partager à partir des informations des documents'
      end
    end

    def render?
      tagset.doc? && tagset.docs.all?(&:pdf?)
    end

    def extract_emails_processing?
      tagset.docs.any? { |doc| doc.extracted_emails_at.nil? }
    end
  end
end
