# frozen_string_literal: true

module ActionButtons
  class SplitButtonComponent < BaseButtonComponent
    attr_reader :tagset, :user

    def initialize(tagset:, user:, show_text: false)
      super(show_text:)
      @tagset = tagset
      @user = user
    end

    def title
      'Découper le document'
    end

    def render?
      return false unless tagset.one_doc? && tagset.docs.to_a.first.pdf?

      SpiritHub::TagsetsPolicy.new(user, tagset).split_form?
    end
  end
end
