# frozen_string_literal: true

module ActionButtons
  class VersionButtonComponent < BaseButtonComponent
    attr_reader :tagset, :user

    def initialize(tagset:, user:, show_text: false)
      super(show_text:)
      @tagset = tagset
      @user = user
    end

    def title
      'Ajouter une nouvelle version'
    end

    def render?
      tagset.doc? && SpiritHub::TagsetsPolicy.new(@user, tagset).versioning?
    end
  end
end
