# frozen_string_literal: true

module ChatbotModal
  class ChannelItemComponent < BaseComponent
    attr_reader :channel, :current_channel, :is_favorite

    def initialize(channel:, current_channel:, is_favorite: false)
      @channel          = channel
      @current_channel  = current_channel
      @is_favorite      = is_favorite

      super
    end

    def classes
      return 'font-bold text-spirit-red' if active?

      'text-gray-700 hover:text-spirit-red'
    end

    def active?
      channel == current_channel
    end

    def actions(channel)
      [
        {
          label: is_favorite ? 'Supprimer des favoris' : 'Ajouter aux favoris',
          path: is_favorite ? unfavorite_spirit_hub_channel_path(channel) : favorite_spirit_hub_channel_path(channel),
          data: {
            turbo_stream: true,
            turbo_method: is_favorite ? 'delete' : 'post',
            action: 'context-menu#close'
          }
        },
        {
          label: 'Supprimer',
          path: spirit_hub_channel_path(channel),
          data: {
            turbo_stream: true,
            turbo_method: 'delete',
            turbo_confirm: 'Êtes-vous certain de vouloir supprimer ce channel ?',
            action: 'context-menu#close'
          }
        }
      ]
    end
  end
end
