# frozen_string_literal: true

module Comment
  class NewModalComponent < BaseComponent
    attr_reader :user, :comment

    def initialize(user, comment)
      @user = user
      @comment = comment
      super
    end

    def channel_key
      "#{@comment.commentable.class.name.underscore}_comments_#{@comment.commentable.id}"
    end

    def form_with_options
      {
        model: comment,
        url: spirit_hub_comments_path,
        data: {
          controller: 'comments'
        },
        class: 'w-full'
      }
    end
  end
end
