# frozen_string_literal: true

module InstantMessages
  class SystemMessageComponent < BaseComponent
    attr_reader :instant_message

    def initialize(instant_message)
      @instant_message = instant_message
      super
    end

    def message_text
      case instant_message.type
      when 'e'
        "Événement en cours : #{instant_message.text}"
      when 'v'
        "Visualisation : #{instant_message.text}"
      when 'llm_tc'
        "Appel d'outil en cours..."
      when 'llm_e'
        instant_message.text
      else
        instant_message.text
      end
    end

    def icon_class
      case instant_message.type
      when 'e', 'v'
        'fa-info-circle'
      when 'llm_tc'
        'fa-cog fa-spin'
      when 'llm_e'
        'fa-robot'
      else
        'fa-circle-notch fa-spin'
      end
    end
  end
end
