# frozen_string_literal: true

module ModelTable
  class SortButtonComponent < BaseComponent
    def initialize(options = {})
      super

      @field = options.fetch(:field)
      @sort_helper_name = options.fetch(:sort_helper_name)
      @label = options.fetch(:label)
      @extra_params = options.fetch(:extra_params, nil)
      @search_params = options.fetch(:search_params, nil)
      @sort_by = options.fetch(:sort_by)
      @sort_direction = options.fetch(:sort_direction)
      @current_sort = @sort_by.to_s == @field.to_s
      @new_direction = @current_sort && @sort_direction == 'asc' ? 'desc' : 'asc'
    end

    def default_params
      params = { sort_by: @field, sort_direction: @new_direction, page: 1, per_page: @per_page }
      params.merge!(@extra_params) if @extra_params
      params.merge!(search_params: @search_params) if @search_params
      params
    end
  end
end
