# frozen_string_literal: true

class SpinnerComponent < ViewComponent::Base
  attr_reader :active, :size, :color, :id

  def initialize(active: false, size: :md, color: 'text-blue-600', id: 'spinner')
    @active = active
    @size   = size
    @color  = color
    @id     = id

    super
  end

  private

  def classes
    base_classes = 'inline animate-spin motion-reduce:block'
    base_classes += ' hidden' unless @active
    size_classes = {
      sm: 'w-4 h-4',
      md: 'w-6 h-6',
      lg: 'w-8 h-8'
    }[@size.to_sym]
    [base_classes, size_classes, @color].join(' ')
  end
end
