# frozen_string_literal: true

module SpiritHub
  class SharedController < ApplicationController
    before_action :find_models, only: %i[index sort]

    include Datatablable

    def index
      authorize(Tagset, policy_class:)

      respond_to(&:html)
    end

    def sort
      authorize(Tagset, policy_class:)

      render partial: 'spirit_hub/shared/table'
    end

    private

    def find_models
      scope = policy_scope(Tagset, policy_scope_class:)

      @models = find_models_page(scope, default_sort_by: 'cleaned_main_key')
    end
  end
end
