# frozen_string_literal: true

module SpiritHub
  module ActorFormatterHelper
    def actors_for_select(*types, **opts)
      actors = []
      actors += User.all.limit(5) if types.include?('users')
      actors += Group.all.limit(5) if types.include?('groups')
      actors += Doc.where(type: 'contact').limit(5) if types.include?('contacts')

      actors_preselected = SpiritHub::ActorFormatter.actors_from_ids(opts[:preselections]) if opts[:preselections].present?
      actors += actors_preselected || []

      SpiritHub::ActorFormatter.actors_to_select(actors)
    end
  end
end
