# frozen_string_literal: true

module SpiritHub
  module TagsetsHelper
    def tagset_doc_complete_name(tagset)
      return tagset.title if tagset.one_doc?

      docs = tagset.find_docs_or_children_docs
      tagset_docs_titles = docs.map(&:title).join(', ')
      "#{tagset.title} [#{docs.length} documents] (#{tagset_docs_titles.truncate(50, omission: '...')})"
    end
  end
end
