# frozen_string_literal: true

module SpiritHub
  module Channels
    class Base < BaseInteractor
      def channel
        @channel ||= Channel.find(params[:id])
      end

      def channel_params
        params.require(:channel).permit(:bot_id, :text, :tagset_id)
      end

      def bot_id
        channel_params[:bot_id]
      end

      def add_instant_message
        @channel.instant_messages.create!(
          user: current_user,
          text: channel_params[:text],
          mentions: [bot_id]
        )
        @channel.update(waiting_for_bot: true)
      rescue ActiveRecord::RecordInvalid => e
        @errors = e.record.errors
      end
    end
  end
end
