# frozen_string_literal: true

module SpiritHub
  module Channels
    class Create < Build
      def call
        super do |channel|
          @channel = channel

          if @channel.save!
            # rename_channel_automatically
            add_instant_message
            @result = @channel.reload
          else
            @errors = @channel.errors
          end
        end
      end

      def rename_channel_automatically
        # Voir avec Olivier comment declancher l'appel d'un tool sur ce channel sans poluer la conversation
        Message.create!(
          text: I18n.t('spirit_hub.channels.create.rename_message', id: @channel.id, context: @channel.description,
                                                                    message: channel_params[:text]),
          user: current_user,
          user_ids: [bot_id]
        )
      end
    end
  end
end
