# frozen_string_literal: true

module SpiritHub
  module Channels
    class Unfavorite < Base
      def call
        super do
          remove_from_favorites
          @result = channel
        end
      end

      private

      def remove_from_favorites
        channel.favorites.where(user_id: current_user.id).destroy
      end
    end
  end
end
