# frozen_string_literal: true

module Commentable
  extend ActiveSupport::Concern

  included do
    def comment_channel
      Channel.find_by(key: comment_channel_key)
    end

    def comment_channel_key
      "#{self.class.name.underscore}_comments_#{id}"
    end
    # Add any other shared methods needed for comments
  end
end
