# frozen_string_literal: true

module SpiritHub
  module LLM
    module Tools
      class OperationsTool < ::LLM::Tools::PawTool
        slug :spirit_hub_operations_tool

        define_function(
          :get_results,
          description: 'OperationsTool: Find Operation records based on different filtering capabilities.'
        ) do
          property(
            :title,
            type: 'string',
            description: 'Filter by operation code.',
            required: false
          )

          property(
            :code,
            type: 'string',
            description: 'Filter by operation code.',
            required: false
          )
        end

        def get_results(**properties)
          Rails.logger.tagged('LLM').debug "Operations Tool Get Results used : #{properties.inspect}"

          query = if properties.present?
                    SpiritHub::Operation.where(properties)
                  else
                    SpiritHub::Operation.none
                  end

          query.all.to_json
        end
      end
    end
  end
end
