# frozen_string_literal: true

module SpiritHub
  module Pdf
    module Annotation
      class Text < Base
        validates :content, presence: true

        def annotation_type
          'freetext'
        end

        # Merge style data into the frontend JSON
        def to_frontend_json
          super.merge(
            fontSize: style_data['fontSize'],
            color: style_data['color']
          )
        end
      end
    end
  end
end
