# frozen_string_literal: true

SPIRIT_HUB_LLM_TOOLS = %w[
  SpiritHub::LLM::Tools::DocsTool
  SpiritHub::LLM::Tools::OperationsTool
  SpiritHub::LLM::Tools::WorkflowTool
].freeze

LLM::Tool.class_eval do
  self.base_tools += SPIRIT_HUB_LLM_TOOLS
end

def ensure_spirit_hub_tools
  SPIRIT_HUB_LLM_TOOLS.each do |base_tool_class|
    Rails.logger.info "[AI] SpiritHub Add #{base_tool_class} LLM tool"

    unless (tool = LLM::Tool.create_from_base(base_tool_class:))
      Rails.logger.info "[AI] SpiritHub LLM tool errors #{tool.errors}"
    end
  end
end

ensure_spirit_hub_tools
