# frozen_string_literal: true

module SuggestableOverrides
  # Monkey-patch app/models/concerns/suggestable.rb method
  def calc_suggests_llm(_user_id) # rubocop:disable Metrics/AbcSize
    # user = User.find_by(id: user_id || responsible)
    similar_docs = get_similars(weight: 0, filter: "doc_id != \"#{id}\"", group_by: 'doc_id')

    similar_docs.each do |res|
      next unless (d = Doc.find_by(id: res['doc_id']))

      # next unless d.readable_by?(user)
      suggest = Suggest.find_or_create_by(doc_id: id, target_id: res['doc_id'])
      suggest.confidence = (res['distance'] * 100).round
      suggest.labels = d.labels.presence

      d_parent_spaces = d.tagsets.flat_map { |tagset| tagset.parent_directories.where(is_space: true) }
      suggest.space_ids = d_parent_spaces.map(&:id)

      if state_id
        suggest.state_ids = workflow_actions.where(
          doc_id: res['doc_id'],
          previous_state_id: state_id.to_s
        ).pluck(:state_id).compact
      end
      suggest.save
    end
  end
end
