# frozen_string_literal: true

module SpiritHub
  class SettingPolicy
    attr_reader :user, :settings

    def initialize(user, settings)
      @user     = user
      @settings = settings
    end

    def index?
      user.admin?
    end

    def inline_edit?
      index?
    end

    def update_inline?
      inline_edit?
    end

    class Scope
      attr_reader :user, :scope

      def initialize(user, scope)
        @user = user
        @scope = scope
      end

      def resolve
        return [] unless user&.admin?

        scope.where(
          id: Setting.new.id
        )
      end
    end
  end
end
