# frozen_string_literal: true

module SpiritHub
  class SharedPolicy
    attr_reader :user, :tagset

    def initialize(user, tagset)
      @user = user
      @tagset = tagset
    end

    def index?
      user.present?
    end

    def sort?
      index?
    end

    class Scope
      attr_reader :user, :scope

      def initialize(user, scope)
        @user = user
        @scope = scope
      end

      def resolve
        scope.where(
          all_can_access: { :$in => user.all_gids_and_user },
          spirit_hubdoc: true,
          type: 'document',
          :informed.nin => [nil, []]
        )
      end
    end
  end
end
