# frozen_string_literal: true

module SpiritHub
  module Docs
    class AfterTextExtracted
      class << self
        def call(*)
          new(*).call
        end
      end

      attr_accessor :doc

      def initialize(doc)
        @doc = doc
      end

      def call
        SpiritHub::Docs::EmailsExtracterJob.perform_later(doc.id.to_s) if doc.extracted_emails_at.nil?
      end
    end
  end
end
