# frozen_string_literal: true

pin '@hotwired/turbo-rails', to: 'turbo.min.js', preload: true
pin '@hotwired/stimulus', to: 'stimulus.min.js', preload: true
pin '@hotwired/stimulus-loading', to: 'stimulus-loading.js', preload: true

pin '@fortawesome/fontawesome-free', to: 'https://ga.jspm.io/npm:@fortawesome/fontawesome-free@6.1.0/js/fontawesome.js'
pin '@fortawesome/fontawesome-svg-core', to: 'https://ga.jspm.io/npm:@fortawesome/fontawesome-svg-core@1.3.0/index.es.js'
pin '@fortawesome/free-brands-svg-icons', to: 'https://ga.jspm.io/npm:@fortawesome/free-brands-svg-icons@6.1.0/index.es.js'
pin '@fortawesome/free-regular-svg-icons', to: 'https://ga.jspm.io/npm:@fortawesome/free-regular-svg-icons@6.1.0/index.es.js'
pin '@fortawesome/free-solid-svg-icons', to: 'https://ga.jspm.io/npm:@fortawesome/free-solid-svg-icons@6.1.0/index.es.js'

pin '@stimulus-components/notification', to: '@stimulus-components--notification.js' # @3.0.0
pin 'stimulus-use' # @0.52.2
pin 'turbo_power' # @0.6.2
pin '@stimulus-components/dropdown', to: '@stimulus-components--dropdown.js' # @3.0.0
pin '@stimulus-components/checkbox-select-all', to: '@stimulus-components--checkbox-select-all.js' # @6.0.0
pin 'debounce' # @2.0.0
pin 'slimselect' # @2.7.1
pin 'pdfjs-dist', to: 'pdf.min.js'
pin 'pdfjs-dist/worker', to: 'pdf.worker.min.js'

pin 'spirit_hub/application', to: 'spirit_hub/application.js', preload: true

pin_all_from SpiritHub::Engine.root.join('app/assets/javascripts/spirit_hub/controllers'), under: 'controllers', to: 'spirit_hub/controllers'
pin_all_from SpiritHub::Engine.root.join('app/assets/javascripts/spirit_hub/helpers'), under: 'helpers', to: 'spirit_hub/helpers'
