Feature: Chatbot

  Scenario: Can open and close chatbot modal
    Given I am a logged in admin
    And There is a bot and some channels
    When I visit the url /spirit_hub
    Then There should not have a chatbot modal
    When I click on the chatbot button
    Then I should see the chatbot modal
    When I click on the close button
    Then I should not see the chatbot modal
    When I click on the chatbot button
    Then I click on the backdrop
    Then I should not see the chatbot modal

  Scenario: New chat
    Given I am a logged in admin
    And There is a bot and some channels
    When I visit the url /spirit_hub
    And I click on the chatbot button
    And I type "Hello new chat" in the chatbot input
    Then I should see the chat message "Hello new chat"
    And I can see the loading spinner
    Given The bot answers
    Then I should see the chat message "Bot Response"
    And I don't see the loading spinner
    And I can see the chat in the list

  Scenario: Update new chat
    Given I am a logged in admin
    And There is a bot and some channels
    When I visit the url /spirit_hub
    When I click on the chatbot button
    And I click on the chat 1 in the chat list
    Then I should see the chat message "Hello chat 1"
    When I click on the chat 2 in the chat list
    Then I should see the chat message "Hello chat 2"
    When I type "A new question" in the chatbot input
    Then I should see the chat message "A new question"
    And I can see the loading spinner
    Given The bot answers
    Then I should see the chat message "Bot Response"
    And I don't see the loading spinner


  Scenario: Add and remove from favorites
    Given I am a logged in admin
    And There is a bot and some channels
    When I visit the url /spirit_hub
    And I click on the chatbot button
    And I add the chat 1 to favorites
    Then I should see the chat 1 in the favorites list
    When I remove the chat 1 from favorites
    Then I should not see the chat 1 in the favorites list

  Scenario: Rename
    Given I am a logged in admin
    And There is a bot and some channels
    When I visit the url /spirit_hub
    And I click on the chatbot button
    And I rename the chat 1 to "New chat name"
    Then I should see the chat 1 with the name "New chat name"

  Scenario: Delete
    Given I am a logged in admin
    And There is a bot and some channels
    When I visit the url /spirit_hub
    And I click on the chatbot button
    And I delete the chat 1
    Then I should not see the chat 1 in the chat list

  Scenario: Chat from doc
    Given I am a logged in admin
    And There is a bot and some channels
    And There is a doc
    When I visit the url /spirit_hub/search?search_params%5Bcleaned_main_key%5D=
    And I click on the chat button of the doc
    Then I should see the chat message "Comment puis-je vous aider avec Doc Title 1 ?"