import { Given, When, Then } from '@badeball/cypress-cucumber-preprocessor';

Given('There is a pdf doc', () => {
  cy.appFactories([['create', 'tagset_doc', 'with_file', { responsible: '1', filename: 'pdf_sample.pdf' }]]);
});

When('I click on the split button', () => {
  cy.get('#model_table tbody tr:first td:last div[data-controller="better-dropdown"] button').first().click();
  cy.get('form[action*="/split_form"] button:visible').first().click();
});

When('I split the file', () => {
  cy.get('input[name="per_page"]').type('2');
  cy.get('button[data-split-target="submitButton"]').click();
  cy.waitForTurboResponse();
});

Then('I should see the split notification', () => {
  cy.get('#flash_messages').contains('Document découpé');
});

When('I click on the split notification', () => {
  cy.get('#flash_messages a').click();
});

Then('I should see the splitted doc', () => {
  cy.get('#model_table').contains('Doc Title 1 (découpé)');
  cy.get('#model_table tbody tr:visible').should('have.length', 3);
});

Given('There is a image doc', () => {
  cy.appFactories([['create', 'tagset_doc', { responsible: '1' }]]);
});

Then("I don't see the split button", () => {
  cy.get('#model_table tbody tr:first td:last div[data-controller="better-dropdown"] button').first().click();
  cy.get('form[action*="/split_form"] button:visible').should('not.exist');
});
