# frozen_string_literal: true

require 'faker'

FactoryBot.define do
  factory :suggest_from_tagset_doc_to_tagset_doc, class: Suggest do
    transient do
      from_tagset_doc_id { nil }
      to_tagset_doc_id { nil }
    end

    before(:create) do |record, evaluator|
      from_tagset_doc = Tagset.find_by!(id: evaluator.from_tagset_doc_id)
      to_tagset_doc = Tagset.find_by!(id: evaluator.to_tagset_doc_id)

      record.doc_id = from_tagset_doc.docs.first.id
      record.target_id = to_tagset_doc.docs.first.id
    end
  end
end
