# frozen_string_literal: true

require 'rails_helper'

RSpec.describe SpiritHub::TeamActivities::CollaboratorPolicy do
  let(:user) { create(:user) }

  subject { described_class }

  permissions :index?, :sort? do
    it 'permits all users' do
      expect(subject).to permit(user)
    end
  end

  describe SpiritHub::TeamActivities::CollaboratorPolicy::Scope do
    let(:user) { create(:user) }
    let(:scope) { Tagset.all }
    let!(:tagset_in) { create(:tagset_doc) }
    let!(:tagset_not_in_spirit) { create(:tagset) }

    subject { described_class.new(user, scope) }

    describe '#resolve' do
      it 'returns the right records' do
        expect(subject.resolve).to eq([tagset_in])
      end
    end
  end
end
