module.exports = {
  content: ['./app/**/*.{html,erb,haml,rb}', './app/helpers/**/*.rb', './app/assets/javascripts/**/*.{js,ts}'],
  theme: {
    extend: {
      fontFamily: {
        'red-hat': ['"Red Hat Text"', 'sans-serif'],
      },
      colors: {
        primary: 'hsl(181, 71%, 13%)',     // dark green
        white: '#FFFFFF',
        black: '#000000',
        spirit: {
          red: 'hsl(1, 71%, 59%)',
          green: 'hsl(181, 71%, 38%)',
          blue: '#2e98e9',
          lightgray: '#606266',
          lightblue: '#B3BEC5',
          gray: 'hsl(181, 13%, 87%)',
          brigthred: '#e20026',
          orange: '#F79009',
        },
      },
      borderRadius: {
        'sm': '2.5px',
        'md': '5px',
      },
      backgroundImage: {
        'gradient-conic': 'conic-gradient(from 45deg, var(--tw-gradient-stops))'
      }
    },
  },
  safelist: [
    'bg-spirit-orange', 'bg-spirit-red', 'bg-spirit-green',
    'text-spirit-orange', 'text-spirit-red', 'text-spirit-green',
    'rounded-sm', 'rounded-md'
  ],
  plugins: [],
};
